test: turn EXPENSIVE into a lazy prerequisite
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
2d14e13c
JK
57 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
58 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f
RR
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
8bade1e1 95unset GITPERLLIB
29e55cd5
JH
96GIT_AUTHOR_EMAIL=author@example.com
97GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
98GIT_COMMITTER_EMAIL=committer@example.com
99GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 100GIT_MERGE_VERBOSITY=5
f8246281
JH
101GIT_MERGE_AUTOEDIT=no
102export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
103export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
104export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 105export EDITOR
e1970ce4 106
a731fa91
EP
107# Add libc MALLOC and MALLOC_PERTURB test
108# only if we are not executing the test with valgrind
1b3185fc 109if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 110 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
111then
112 setup_malloc_check () {
113 : nothing
114 }
115 teardown_malloc_check () {
116 : nothing
117 }
118else
119 setup_malloc_check () {
120 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
121 export MALLOC_CHECK_ MALLOC_PERTURB_
122 }
123 teardown_malloc_check () {
124 unset MALLOC_CHECK_ MALLOC_PERTURB_
125 }
126fi
a731fa91 127
886a3907
JH
128# Protect ourselves from common misconfiguration to export
129# CDPATH into the environment
130unset CDPATH
131
5565f47c 132unset GREP_OPTIONS
ac001282 133unset UNZIP
5565f47c 134
3d5c0cc9 135case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1361|2|true)
137 echo "* warning: Some tests will not work if GIT_TRACE" \
138 "is set as to trace on STDERR ! *"
139 echo "* warning: Please set GIT_TRACE to something" \
140 "other than 1, 2 or true ! *"
141 ;;
6ce4e61f
CC
142esac
143
cd3c095c
JH
144# Convenience
145#
146# A regexp to match 5 and 40 hexdigits
147_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
148_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
149
3749fde5
JH
150# Zero SHA-1
151_z40=0000000000000000000000000000000000000000
152
3f4ab627
JH
153# Line feed
154LF='
155'
156
342e9ef2
TR
157export _x05 _x40 _z40 LF
158
e1970ce4
JH
159# Each test should start with something like this, after copyright notices:
160#
161# test_description='Description of this test...
162# This test checks if command xyzzy does the right thing...
163# '
164# . ./test-lib.sh
c2116a17
JH
165[ "x$ORIGINAL_TERM" != "xdumb" ] && (
166 TERM=$ORIGINAL_TERM &&
167 export TERM &&
168 [ -t 1 ] &&
169 tput bold >/dev/null 2>&1 &&
170 tput setaf 1 >/dev/null 2>&1 &&
171 tput sgr0 >/dev/null 2>&1
172 ) &&
55db1df0 173 color=t
e1970ce4 174
e1970ce4
JH
175while test "$#" -ne 0
176do
177 case "$1" in
178 -d|--d|--de|--deb|--debu|--debug)
179 debug=t; shift ;;
886856ab
JH
180 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
181 immediate=t; shift ;;
5e2c08c6 182 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 183 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 184 -h|--h|--he|--hel|--help)
570f3226 185 help=t; shift ;;
e1970ce4
JH
186 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
187 verbose=t; shift ;;
ff09af3f
TR
188 --verbose-only=*)
189 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
190 shift ;;
1ece1274 191 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
192 # Ignore --quiet under a TAP::Harness. Saying how many tests
193 # passed without the ok/not ok details is always an error.
194 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
195 --with-dashes)
196 with_dashes=t; shift ;;
55db1df0 197 --no-color)
faa4bc35 198 color=; shift ;;
4e1be63c 199 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
200 valgrind=memcheck
201 shift ;;
202 --valgrind=*)
203 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
204 shift ;;
5dfc368f
TR
205 --valgrind-only=*)
206 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
207 shift ;;
44138559
JS
208 --tee)
209 shift ;; # was handled already
f423ef5f
JK
210 --root=*)
211 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
e1970ce4 213 *)
1f729dca 214 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
215 esac
216done
217
26a07309 218if test -n "$valgrind_only"
5dfc368f
TR
219then
220 test -z "$valgrind" && valgrind=memcheck
221 test -z "$verbose" && verbose_only="$valgrind_only"
222elif test -n "$valgrind"
223then
224 verbose=t
225fi
952af351 226
1c0cc756
RJ
227if test -n "$color"
228then
55db1df0 229 say_color () {
c2116a17
JH
230 (
231 TERM=$ORIGINAL_TERM
232 export TERM
55db1df0 233 case "$1" in
1c0cc756
RJ
234 error)
235 tput bold; tput setaf 1;; # bold red
236 skip)
b8fc855a 237 tput setaf 4;; # blue
e8e51955
AS
238 warn)
239 tput setaf 3;; # brown/yellow
1c0cc756 240 pass)
0a6d4751 241 tput setaf 2;; # green
1c0cc756 242 info)
0a6d4751 243 tput setaf 6;; # cyan
1c0cc756
RJ
244 *)
245 test -n "$quiet" && return;;
55db1df0
PH
246 esac
247 shift
5099b99d 248 printf "%s" "$*"
55db1df0 249 tput sgr0
b8eecafd 250 echo
c2116a17 251 )
55db1df0
PH
252 }
253else
254 say_color() {
1ece1274 255 test -z "$1" && test -n "$quiet" && return
55db1df0 256 shift
7bc0911d 257 printf "%s\n" "$*"
55db1df0
PH
258 }
259fi
260
261error () {
262 say_color error "error: $*"
6e7b5aaf 263 GIT_EXIT_OK=t
55db1df0
PH
264 exit 1
265}
266
267say () {
268 say_color info "$*"
269}
270
570f3226
MB
271test "${test_description}" != "" ||
272error "Test script did not set test_description."
273
274if test "$help" = "t"
275then
276 echo "$test_description"
277 exit 0
278fi
279
4d9d62fa 280exec 5>&1
781f76b1 281exec 6<&0
e1970ce4
JH
282if test "$verbose" = "t"
283then
284 exec 4>&2 3>&1
285else
286 exec 4>/dev/null 3>/dev/null
287fi
288
289test_failure=0
290test_count=0
41ac414e
JH
291test_fixed=0
292test_broken=0
2d84e9fb 293test_success=0
e1970ce4 294
d998bd4a
ÆAB
295test_external_has_tap=0
296
faa4bc35 297die () {
6e7b5aaf
CB
298 code=$?
299 if test -n "$GIT_EXIT_OK"
300 then
301 exit $code
302 else
303 echo >&5 "FATAL: Unexpected exit with code $code"
304 exit 1
305 fi
faa4bc35
CB
306}
307
6e7b5aaf 308GIT_EXIT_OK=
35641310 309trap 'die' EXIT
41184273 310
12a29b1a
TR
311# The user-facing functions are loaded from a separate file so that
312# test_perf subshells can have them too
3c8f12c9 313. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 314
886856ab 315# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 316# the test_expect_* functions instead.
886856ab
JH
317
318test_ok_ () {
d5d9de1b 319 test_success=$(($test_success + 1))
633fe50a 320 say_color "" "ok $test_count - $@"
e1970ce4
JH
321}
322
886856ab 323test_failure_ () {
d5d9de1b 324 test_failure=$(($test_failure + 1))
633fe50a 325 say_color error "not ok $test_count - $1"
bf0dd8a8 326 shift
5099b99d 327 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 328 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
329}
330
41ac414e 331test_known_broken_ok_ () {
41ac414e 332 test_fixed=$(($test_fixed+1))
633fe50a 333 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
334}
335
336test_known_broken_failure_ () {
41ac414e 337 test_broken=$(($test_broken+1))
633fe50a 338 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 339}
886856ab
JH
340
341test_debug () {
8e832ebc 342 test "$debug" = "" || eval "$1"
e1970ce4
JH
343}
344
e6a6ddc9
TR
345match_pattern_list () {
346 arg="$1"
347 shift
348 test -z "$*" && return 1
349 for pattern_
350 do
351 case "$arg" in
352 $pattern_)
353 return 0
354 esac
355 done
356 return 1
357}
358
ff09af3f
TR
359maybe_teardown_verbose () {
360 test -z "$verbose_only" && return
361 exec 4>/dev/null 3>/dev/null
362 verbose=
363}
364
365last_verbose=t
366maybe_setup_verbose () {
367 test -z "$verbose_only" && return
26a07309 368 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
369 then
370 exec 4>&2 3>&1
371 # Emit a delimiting blank line when going from
372 # non-verbose to verbose. Within verbose mode the
373 # delimiter is printed by test_expect_*. The choice
374 # of the initial $last_verbose is such that before
375 # test 1, we do not print it.
376 test -z "$last_verbose" && echo >&3 ""
377 verbose=t
378 else
379 exec 4>/dev/null 3>/dev/null
380 verbose=
381 fi
382 last_verbose=$verbose
383}
384
5dfc368f
TR
385maybe_teardown_valgrind () {
386 test -z "$GIT_VALGRIND" && return
387 GIT_VALGRIND_ENABLED=
388}
389
390maybe_setup_valgrind () {
391 test -z "$GIT_VALGRIND" && return
26a07309 392 if test -z "$valgrind_only"
5dfc368f
TR
393 then
394 GIT_VALGRIND_ENABLED=t
395 return
396 fi
397 GIT_VALGRIND_ENABLED=
398 if match_pattern_list $test_count $valgrind_only
399 then
400 GIT_VALGRIND_ENABLED=t
401 fi
402}
403
a7c58f28
JN
404test_eval_ () {
405 # This is a separate function because some tests use
406 # "return" to end a test_expect_success block early.
781f76b1 407 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
408}
409
4d9d62fa 410test_run_ () {
b6b0afdc 411 test_cleanup=:
b586744a 412 expecting_failure=$2
a57397b0 413 setup_malloc_check
a7c58f28 414 test_eval_ "$1"
b6b0afdc 415 eval_ret=$?
a57397b0 416 teardown_malloc_check
b586744a
JH
417
418 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
419 then
1b3185fc 420 setup_malloc_check
a7c58f28 421 test_eval_ "$test_cleanup"
1b3185fc 422 teardown_malloc_check
b586744a 423 fi
1c0cc756
RJ
424 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
425 then
57e1538a
ÆAB
426 echo ""
427 fi
aa0bcf96 428 return "$eval_ret"
4d9d62fa
PR
429}
430
ae75342c 431test_start_ () {
8586f98b 432 test_count=$(($test_count+1))
ff09af3f 433 maybe_setup_verbose
5dfc368f 434 maybe_setup_valgrind
ae75342c
TR
435}
436
437test_finish_ () {
438 echo >&3 ""
5dfc368f 439 maybe_teardown_valgrind
ff09af3f 440 maybe_teardown_verbose
ae75342c
TR
441}
442
443test_skip () {
04ece593 444 to_skip=
e6a6ddc9
TR
445 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
446 then
447 to_skip=t
448 fi
05236a5e
JN
449 if test -z "$to_skip" && test -n "$test_prereq" &&
450 ! test_have_prereq "$test_prereq"
a7bb3940
JS
451 then
452 to_skip=t
453 fi
04ece593
JH
454 case "$to_skip" in
455 t)
07431fc8 456 of_prereq=
05236a5e 457 if test "$missing_prereq" != "$test_prereq"
07431fc8 458 then
05236a5e 459 of_prereq=" of $test_prereq"
07431fc8
JN
460 fi
461
633fe50a
TR
462 say_color skip >&3 "skipping test: $@"
463 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
464 : true
465 ;;
466 *)
467 false
468 ;;
469 esac
470}
471
342e9ef2
TR
472# stub; perf-lib overrides it
473test_at_end_hook_ () {
474 :
475}
476
e1970ce4 477test_done () {
6e7b5aaf 478 GIT_EXIT_OK=t
2d84e9fb 479
517cd55f
TR
480 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
481 # output file
1c0cc756
RJ
482 if test -z "$HARNESS_ACTIVE"
483 then
342e9ef2 484 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 485 mkdir -p "$test_results_dir"
dd78478f
FC
486 base=${0##*/}
487 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 488
c54e6be7
ML
489 cat >>"$test_results_path" <<-EOF
490 total $test_count
491 success $test_success
492 fixed $test_fixed
493 broken $test_broken
494 failed $test_failure
495
496 EOF
8ef1abe5 497 fi
41ac414e
JH
498
499 if test "$test_fixed" != 0
500 then
633fe50a 501 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
502 fi
503 if test "$test_broken" != 0
504 then
633fe50a 505 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
506 fi
507 if test "$test_broken" != 0 || test "$test_fixed" != 0
508 then
509 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
510 msg="remaining $test_remaining test(s)"
11d54b8b 511 else
b73d9a23 512 test_remaining=$test_count
11d54b8b 513 msg="$test_count test(s)"
41ac414e 514 fi
e1970ce4 515 case "$test_failure" in
10b94e28 516 0)
5099b99d 517 # Maybe print SKIP message
bf4b7219
RJ
518 if test -n "$skip_all" && test $test_count -gt 0
519 then
520 error "Can't use skip_all after running some tests"
521 fi
5099b99d
ÆAB
522 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
523
1c0cc756
RJ
524 if test $test_external_has_tap -eq 0
525 then
b73d9a23 526 if test $test_remaining -gt 0
d87bd7c1 527 then
633fe50a 528 say_color pass "# passed all $msg"
d87bd7c1 529 fi
633fe50a 530 say "1..$test_count$skip_all"
d998bd4a 531 fi
abc5d372
JS
532
533 test -d "$remove_trash" &&
534 cd "$(dirname "$remove_trash")" &&
535 rm -rf "$(basename "$remove_trash")"
536
342e9ef2
TR
537 test_at_end_hook_
538
e1970ce4
JH
539 exit 0 ;;
540
541 *)
1c0cc756
RJ
542 if test $test_external_has_tap -eq 0
543 then
633fe50a
TR
544 say_color error "# failed $test_failure among $msg"
545 say "1..$test_count"
d998bd4a 546 fi
5099b99d 547
e1970ce4
JH
548 exit 1 ;;
549
550 esac
551}
552
e4597aae 553if test -n "$valgrind"
4e1be63c 554then
4e1be63c
JS
555 make_symlink () {
556 test -h "$2" &&
557 test "$1" = "$(readlink "$2")" || {
558 # be super paranoid
559 if mkdir "$2".lock
560 then
561 rm -f "$2" &&
562 ln -s "$1" "$2" &&
563 rm -r "$2".lock
564 else
565 while test -d "$2".lock
566 do
567 say "Waiting for lock on $2."
568 sleep 1
569 done
570 fi
571 }
572 }
573
574 make_valgrind_symlink () {
36bfb0e5
JK
575 # handle only executables, unless they are shell libraries that
576 # need to be in the exec-path. We will just use "#!" as a
577 # guess for a shell-script, since we have no idea what the user
578 # may have configured as the shell path.
579 test -x "$1" ||
580 test "#!" = "$(head -c 2 <"$1")" ||
581 return;
4e1be63c
JS
582
583 base=$(basename "$1")
6cec5c68 584 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
585 # do not override scripts
586 if test -x "$symlink_target" &&
587 test ! -d "$symlink_target" &&
588 test "#!" != "$(head -c 2 < "$symlink_target")"
589 then
590 symlink_target=../valgrind.sh
591 fi
efd92ffd
JS
592 case "$base" in
593 *.sh|*.perl)
594 symlink_target=../unprocessed-script
595 esac
4e1be63c
JS
596 # create the link, or replace it if it is out of date
597 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
598 }
599
26a07309
TR
600 # override all git executables in TEST_DIRECTORY/..
601 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
602 mkdir -p "$GIT_VALGRIND"/bin
603 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
604 do
605 make_valgrind_symlink $file
606 done
607 # special-case the mergetools loadables
608 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
609 OLDIFS=$IFS
610 IFS=:
611 for path in $PATH
612 do
613 ls "$path"/git-* 2> /dev/null |
614 while read file
ad0e6233 615 do
26a07309 616 make_valgrind_symlink "$file"
ad0e6233 617 done
26a07309
TR
618 done
619 IFS=$OLDIFS
4e1be63c
JS
620 PATH=$GIT_VALGRIND/bin:$PATH
621 GIT_EXEC_PATH=$GIT_VALGRIND/bin
622 export GIT_VALGRIND
952af351
TR
623 GIT_VALGRIND_MODE="$valgrind"
624 export GIT_VALGRIND_MODE
5dfc368f 625 GIT_VALGRIND_ENABLED=t
26a07309 626 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 627 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
628elif test -n "$GIT_TEST_INSTALLED"
629then
e4597aae
MO
630 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
631 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 632 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
633 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
634else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 635 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
636 if ! test -x "$git_bin_dir/git"
637 then
638 if test -z "$with_dashes"
639 then
e4597aae
MO
640 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
641 fi
642 with_dashes=t
643 fi
644 PATH="$git_bin_dir:$PATH"
6cec5c68 645 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
646 if test -n "$with_dashes"
647 then
6cec5c68 648 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 649 fi
4e1be63c 650fi
6cec5c68 651GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 652unset GIT_CONFIG
8bfa6bd6 653GIT_CONFIG_NOSYSTEM=1
3c995beb 654GIT_ATTR_NOSYSTEM=1
8f323c00 655export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 656
5e87eae9
JH
657if test -z "$GIT_TEST_CMP"
658then
659 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
660 then
661 GIT_TEST_CMP="$DIFF -c"
662 else
663 GIT_TEST_CMP="$DIFF -u"
664 fi
665fi
666
6cec5c68 667GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 668export GITPERLLIB
6cec5c68 669test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
670 error "You haven't built things yet, have you?"
671}
e1970ce4 672
1c0cc756
RJ
673if ! test -x "$GIT_BUILD_DIR"/test-chmtime
674then
56cf9806
EW
675 echo >&2 'You need to build test-chmtime:'
676 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
677 exit 1
678fi
679
e1970ce4 680# Test repository
002d4ce8
JK
681TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
682test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
683case "$TRASH_DIRECTORY" in
684/*) ;; # absolute path is good
685 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 686esac
91c8b825 687test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 688rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 689 GIT_EXIT_OK=t
8d14ac94
JH
690 echo >&5 "FATAL: Cannot prepare test area"
691 exit 1
692}
693
90cff968
AR
694HOME="$TRASH_DIRECTORY"
695export HOME
696
1c0cc756
RJ
697if test -z "$TEST_NO_CREATE_REPO"
698then
38b074de 699 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 700else
38b074de 701 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 702fi
1bd9c648
LW
703# Use -P to resolve symlinks in our working directory so that the cwd
704# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 705cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 706
d5d9de1b
JS
707this_test=${0##*/}
708this_test=${this_test%%-*}
e6a6ddc9
TR
709if match_pattern_list "$this_test" $GIT_SKIP_TESTS
710then
711 say_color info >&3 "skipping test $this_test altogether"
712 skip_all="skip all tests in $this_test"
713 test_done
714fi
f17e9fbb 715
8648732e
BC
716# Provide an implementation of the 'yes' utility
717yes () {
718 if test $# = 0
719 then
720 y=y
721 else
722 y="$*"
723 fi
724
725 while echo "$y"
726 do
727 :
728 done
729}
730
f17e9fbb
JS
731# Fix some commands on Windows
732case $(uname -s) in
733*MINGW*)
734 # Windows has its own (incompatible) sort and find
735 sort () {
736 /usr/bin/sort "$@"
737 }
738 find () {
739 /usr/bin/find "$@"
740 }
5397ea31
JS
741 sum () {
742 md5sum "$@"
743 }
4114156a
JS
744 # git sees Windows-style pwd
745 pwd () {
746 builtin pwd -W
747 }
ee9fb68c 748 # no POSIX permissions
6fd1106a 749 # backslashes in pathspec are converted to '/'
fb9a2bea 750 # exec does not inherit the PID
a94114ad 751 test_set_prereq MINGW
cfa96496 752 test_set_prereq NOT_CYGWIN
a31d0665 753 test_set_prereq SED_STRIPS_CR
97669eed 754 test_set_prereq GREP_STRIPS_CR
4d715ac0 755 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
756 ;;
757*CYGWIN*)
758 test_set_prereq POSIXPERM
a31d0665
RJ
759 test_set_prereq EXECKEEPSPID
760 test_set_prereq NOT_MINGW
cfa96496 761 test_set_prereq CYGWIN
a31d0665 762 test_set_prereq SED_STRIPS_CR
97669eed 763 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
764 ;;
765*)
766 test_set_prereq POSIXPERM
6fd1106a 767 test_set_prereq BSLASHPSPEC
fb9a2bea 768 test_set_prereq EXECKEEPSPID
3ba9ba8f 769 test_set_prereq NOT_MINGW
cfa96496 770 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
771 ;;
772esac
704a3143 773
b082687c 774( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 775test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 776test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 777test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 778test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 779
bb946bba 780# Can we rely on git's output in the C locale?
30955229
JN
781if test -n "$GETTEXT_POISON"
782then
783 GIT_GETTEXT_POISON=YesPlease
784 export GIT_GETTEXT_POISON
5e9637c6 785 test_set_prereq GETTEXT_POISON
30955229
JN
786else
787 test_set_prereq C_LOCALE_OUTPUT
788fi
bb946bba 789
cabdee2c
JH
790# Use this instead of test_cmp to compare files that contain expected and
791# actual output from git commands that can be translated. When running
792# under GETTEXT_POISON this pretends that the command produced expected
793# results.
794test_i18ncmp () {
795 test -n "$GETTEXT_POISON" || test_cmp "$@"
796}
797
127df8c6
JH
798# Use this instead of "grep expected-string actual" to see if the
799# output from a git command that can be translated either contains an
800# expected string, or does not contain an unwanted one. When running
801# under GETTEXT_POISON this pretends that the command produced expected
802# results.
803test_i18ngrep () {
804 if test -n "$GETTEXT_POISON"
805 then
806 : # pretend success
807 elif test "x!" = "x$1"
808 then
809 shift
810 ! grep "$@"
811 else
812 grep "$@"
813 fi
814}
815
20073274
AS
816test_lazy_prereq PIPE '
817 # test whether the filesystem supports FIFOs
9443605b
ML
818 case $(uname -s) in
819 CYGWIN*)
820 false
821 ;;
822 *)
823 rm -f testfifo && mkfifo testfifo
824 ;;
825 esac
20073274
AS
826'
827
04083f27
JH
828test_lazy_prereq SYMLINKS '
829 # test whether the filesystem supports symbolic links
830 ln -s x y && test -h y
831'
c91cfd19 832
ac39aa61
MG
833test_lazy_prereq CASE_INSENSITIVE_FS '
834 echo good >CamelCase &&
835 echo bad >camelcase &&
836 test "$(cat CamelCase)" != good
837'
838
5b0b5dd4
MG
839test_lazy_prereq UTF8_NFD_TO_NFC '
840 # check whether FS converts nfd unicode to nfc
841 auml=$(printf "\303\244")
842 aumlcdiar=$(printf "\141\314\210")
843 >"$auml" &&
844 case "$(echo *)" in
845 "$aumlcdiar")
846 true ;;
847 *)
848 false ;;
849 esac
850'
851
09feffb6
JK
852test_lazy_prereq AUTOIDENT '
853 sane_unset GIT_AUTHOR_NAME &&
854 sane_unset GIT_AUTHOR_EMAIL &&
855 git var GIT_AUTHOR_IDENT
856'
857
6219bb22
JH
858test_lazy_prereq EXPENSIVE '
859 test -n "$GIT_TEST_LONG"
860'
861
c91cfd19
ÆAB
862# When the tests are run as root, permission tests will report that
863# things are writable when they shouldn't be.
864test -w / || test_set_prereq SANITY
f838ce58
JK
865
866GIT_UNZIP=${GIT_UNZIP:-unzip}
867test_lazy_prereq UNZIP '
868 "$GIT_UNZIP" -v
869 test $? -ne 127
870'